package com.schbrain.canal.client.utils;

import com.alibaba.otter.canal.protocol.CanalEntry;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zhuyf
 * @date 2022/6/22
 */
public class DataUtil {

    public static Map<String, Object> getCloumData(List<CanalEntry.Column> columns){
        Map<String, Object> row = new HashMap<>();
        for (CanalEntry.Column column : columns) {
            if (column.getIsNull()) {
                row.put(column.getName(), null);
            } else {
                row.put(column.getName(),column.getValue());
            }
        }
        return row;
    }
}
