package com.schbrain.web;

import com.schbrain.canal.client.event.ResolverCanalEvent;
import com.schbrain.canal.client.event.SimpleResolverCanalEvent;

import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;

/**
 * @author zhuyf
 * @date 2022/6/22
 */
public class MyCanalEvent6Test {

    public static void main(String[] args) {
        Class g = null;
        MyCanalEvent7 event5 = new MyCanalEvent7();
        Class c = event5.getClass();
        while(true){
            Class aClass = interfaceGeneric(event5);
            if(aClass!=null){
                g = aClass;
                break;
            }
            Type type  = c.getGenericSuperclass();
            if(type instanceof ParameterizedType){
                ParameterizedType parameterizedType = (ParameterizedType)type;
                Type[] types = parameterizedType.getActualTypeArguments();
                if(types!= null && types.length>0){
                    g  = (Class) types[0];
                    break;
                }
            }
            c = c.getSuperclass();
        }
        System.out.println(g);
    }

    /**
     * 接口泛型缓存
     * @param event
     * @return
     */
    private static Class interfaceGeneric(ResolverCanalEvent<?> event){
        Type[] types = event.getClass().getGenericInterfaces();
        if(types == null || types.length == 0){
            return null;
        }
        for (Type type : types) {
            if(!(type instanceof ParameterizedType)){
                continue;
            }
            ParameterizedType parameterized  = (ParameterizedType)type;
            Type rawType = parameterized.getRawType();
            if(rawType.equals(ResolverCanalEvent.class)){
                Class clazz = (Class)parameterized.getActualTypeArguments()[0];
                return clazz;
            }
        }
        return null;
    }
}
